namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Beast Boost is an ability that raises the user's highest stat by one stage when it knocks out another Pokémon.
/// If multiple stats are tied for the highest, the stat that is raised is chosen in this order: Attack, Defense, Special Attack, Special Defense, Speed.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Beast_Boost_(Ability)">Bulbapedia - Beast Boost</see>
/// </summary>
[Script(ScriptCategory.Ability, "beast_boost")]
public class BeastBoost : Script, IScriptOnOpponentFaints
{
    /// <inheritdoc />
    public void OnOpponentFaints(IExecutingMove move, IPokemon target, byte hit)
    {
        var highestStat = move.User.BoostedStats.OrderByDescending(x => x.value).First().statistic;
        EventBatchId batchId = new();
        move.User.BattleData?.Battle.EventHook.Invoke(new AbilityTriggerEvent(move.User)
        {
            BatchId = batchId,
        });
        move.User.ChangeStatBoost(highestStat, 1, true, false, batchId);
    }
}